#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire10four4xi.py">
#<abstract4xi abstract = "fires to direction three two and to distance 10"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire10four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four104xi            # 10   - 90 



#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

      
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + ) - CREATED BY LOAD2FOUR4XI.PY
# -------------------------------------------------------------------------------------------------    

shot2four104xi = {
                1:'0x-9y2z',
                2:'11x-23y53z',
                3:'11x-9y47z',
                4:'12x-15y2z',
                5:'12x-23y53z',
                6:'12x-9y47z',
                7:'13x-14y2z',
                8:'13x-9y47z',
                9:'14x-13y1z',
                10:'14x-14y1z',
                11:'14x-23y53z',
                12:'14x-8y47z',
                13:'15x-12y1z',
                14:'15x-23y53z',
                15:'15x-7y46z',
                16:'16x-10y1z',
                17:'16x-11y1z',
                18:'16x-6y46z',
                19:'17x-22y52z',
                20:'17x-5y46z',
                21:'17x-6y46z',
                22:'17x-9y0z',
                23:'18x-22y52z',
                24:'18x-4y46z',
                25:'18x-7y0z',
                26:'18x-8y0z',
                27:'19x-2y45z',
                28:'19x-3y45z',
                29:'19x-6y0z',
                30:'1x-1y29z',
                31:'1x-9y2z',
                32:'20x-21y52z',
                33:'21x-20y51z',
                34:'21x-45y62z',
                35:'23x-19y51z',
                36:'23x-44y61z',
                37:'24x-18y51z',
                38:'24x-1y54z',
                39:'25x0y54z',
                40:'26x-43y61z',
                41:'28x-7y0z',
                42:'29x-3y0z',
                43:'29x-42y60z',
                44:'29x-4y0z',
                45:'29x-6y0z',
                46:'2x-1y29z',
                47:'2x-7y39z',
                48:'2x-9y1z',
                49:'2x-9y2z',
                50:'30x-20y59z',
                51:'31x-19y59z',
                52:'31x-41y60z',
                53:'33x-18y58z',
                54:'34x-16y58z',
                55:'34x-40y59z',
                56:'36x-15y57z',
                57:'36x-39y59z',
                58:'37x-13y57z',
                59:'38x-11y57z',
                60:'39x-37y58z',
                61:'39x-9y56z',
                62:'3x-1y29z',
                63:'3x-7y39z',
                64:'3x-8y38z',
                65:'3x-9y1z',
                66:'40x-7y56z',
                67:'41x-35y58z',
                68:'41x-5y55z',
                69:'42x-3y55z',
                70:'43x-1y55z',
                71:'43x-33y57z',
                72:'46x-31y57z',
                73:'48x-29y56z',
                74:'4x-1y29z',
                75:'4x-8y1z',
                76:'4x-8y38z',
                77:'4x-9y1z',
                78:'56x-30y63z',
                79:'5x-8y1z',
                80:'5x-8y38z',
                81:'6x-1y39z',
                82:'6x-8y38z',
                83:'6x0y39z',
                84:'7x-8y38z',
                85:'7x0y39z',
                86:'8x-8y38z',
                87:'9x-23y54z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "firefour4xi" usage = "target function for charge104xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire10four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE10FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE10FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE10FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE10FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE10FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four104xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE10FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE10FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE10FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four104xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four104xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE10FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE10FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE10FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire10four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                      